unit ComponentPageRequest;

interface

uses
  Dialogs, Windows, Classes, SmartEdit, CustomFileSystem, LocalFileSystem,
  VirtualFileSystem, FTPLoginDialog, FTPFileSystem, FileListExplorer,
  FolderComboBox, FolderTreeExplorer, FileSystemBrowseDialog, FileSystemOpenDialog,
  FileSystemSaveDialog, UnitHandler, PipeConnection, TCPConnection, IniFiles;

procedure Register;

implementation

procedure Register;
var
  ComponentPage:string;
  f:TIniFile;
  s:array[0..MAX_PATH] of Char;
begin
  Beep(440,100);
  GetModuleFileName(HInstance,@s[0],MAX_PATH);
  f:=TIniFile.Create(s+'.ini');
  ComponentPage:=f.ReadString('General','Palette component page','');
  if (ComponentPage='') or (GetKeyState(VK_LSHIFT)<>0) then begin
    ComponentPage:='FileSystem';
    if not InputQuery('Registering components...','Please chose a component palette page to install the package:',ComponentPage) then
      Exit;
    f.WriteString('General','Palette component page',ComponentPage);
  end;
  f.Destroy;
  RegisterComponents(ComponentPage,[TLocalFileSystem]);
  RegisterComponents(ComponentPage,[TSmartEdit]);
  RegisterComponents(ComponentPage,[TFTPLoginDialog]);
  RegisterComponents(ComponentPage,[TFTPFileSystem]);
  RegisterComponents(ComponentPage,[TVirtualFileSystem]);
  RegisterComponents(ComponentPage,[TFileListExplorer]);
  RegisterComponents(ComponentPage,[TFolderComboBox]);
  RegisterComponents(ComponentPage,[TFolderTreeExplorer]);
  RegisterComponents(ComponentPage,[TFileSystemOpenDialog]);
  RegisterComponents(ComponentPage,[TFileSystemSaveDialog]);
  RegisterComponents(ComponentPage,[TUnitsManager]);
  RegisterComponents(ComponentPage,[TPipeConnectionServer,TPipeConnectionClient]);
  RegisterComponents(ComponentPage,[TTCPConnectionServer,TTCPConnectionClient]);
end;

end.
