unit FTPLoginDialog;

interface

uses
  SysUtils, Classes, Controls, FTPLoginForm;

type
  TFTPLoginDialog = class(TComponent)
  private
    FFTPLoginForm:TFTPLoginFormDialog;

    function GetHost: string;
    function GetPassWord: string;
    function GetUserName: string;
    procedure SetHost(const Value: string);
    procedure SetPassWord(const Value: string);
    procedure SetUserName(const Value: string);
  protected
  public
    constructor Create(AOwner:TComponent);override;

    property Host:string read GetHost write SetHost;
    property UserName:string read GetUserName write SetUserName;
    property PassWord:string read GetPassWord write SetPassWord;

    function Execute:Boolean;
  published
  end;

implementation

{ TFTPLoginDialog }

constructor TFTPLoginDialog.Create(AOwner: TComponent);
begin
  inherited;
  FFTPLoginForm:=TFTPLoginFormDialog.Create(Self);
end;

function TFTPLoginDialog.Execute: Boolean;
begin
  Result:=FFTPLoginForm.ShowModal=mrOk;
end;

function TFTPLoginDialog.GetHost: string;
begin
  Result:=FFTPLoginForm.SmartEdit1.Text;
end;

function TFTPLoginDialog.GetPassWord: string;
begin
  Result:=FFTPLoginForm.Edit1.Text;
end;

function TFTPLoginDialog.GetUserName: string;
begin
  Result:=FFTPLoginForm.SmartEdit2.Text;
end;

procedure TFTPLoginDialog.SetHost(const Value: string);
begin
  FFTPLoginForm.SmartEdit1.Text:=Value;
end;

procedure TFTPLoginDialog.SetPassWord(const Value: string);
begin
  FFTPLoginForm.Edit1.Text:=Value;
end;

procedure TFTPLoginDialog.SetUserName(const Value: string);
begin
  FFTPLoginForm.SmartEdit2.Text:=Value;
end;

end.
 