unit FileSystemOpenDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FileSystemBrowseDialog, ImgList, Menus, FileListExplorer, SmartEdit,
  StdCtrls, FolderComboBox, ExtCtrls, ToolWin, ComCtrls, CustomFileSystem;

type
  TFileSystemOpenDialogOption=(ooResize,ooFileMustExist,ooExtensionMustMatch,ooMultiSelect,ooReadOnlyFileSystem);

  TFileSystemOpenDialogOptions=set of TFileSystemOpenDialogOption;

  TFileSystemOpenDialogForm = class(TFileSystemBrowseDialogForm)
    procedure FormShow(Sender: TObject);
  private
    FOptions: TFileSystemOpenDialogOptions;
  public
    function CheckSmartEdit:Boolean;override;
  end;

  TFileSystemOpenDialog=class(TFileSystemBrowseDialog)
  private
    FOptions: TFileSystemOpenDialogOptions;
  protected
    function GetFileSystemBrowseDialogFormClass:TFileSystemBrowseDialogFormClass;override;

    procedure DoExecute;override;
  public
  published
    constructor Create(AOwner:TComponent);override;

    property Options:TFileSystemOpenDialogOptions read FOptions write FOptions;

    destructor Destroy;override;
  end;

implementation

{$R *.dfm}

{ TFileSystemOpenDialog }

constructor TFileSystemOpenDialog.Create(AOwner: TComponent);
begin
  inherited;
end;

destructor TFileSystemOpenDialog.Destroy;
begin
  inherited;
end;

procedure TFileSystemOpenDialog.DoExecute;
begin
  inherited;
  TFileSystemOpenDialogForm(FFileSystemBrowseDialogForm).FOptions:=FOptions;
  if ooResize in FOptions then
    FFileSystemBrowseDialogForm.BorderStyle:=bsSizeable
  else
    FFileSystemBrowseDialogForm.BorderStyle:=bsDialog;
end;

function TFileSystemOpenDialog.GetFileSystemBrowseDialogFormClass: TFileSystemBrowseDialogFormClass;
begin
  Result:=TFileSystemOpenDialogForm;
end;

{ TFileSystemOpenDialogForm }

function TFileSystemOpenDialogForm.CheckSmartEdit: Boolean;
var
  k:TCharSet;
  a:Integer;
  s,t:string;
begin
  Result:=inherited CheckSmartEdit;
  s:=SmartEdit1.Text;
  if ooMultiSelect in FOptions then
    k:=['/','\',':','"','<','>']
  else
    k:=['|','/','\',':','"','<','>'];
  for a:=1 to Length(s) do
    Result:=Result and not (s[a] in k);
  FFiles.DelimitedText:=s;
  t:='';
  if ComboBox1.ItemIndex>-1 then
    t:=FFilters[2*ComboBox1.ItemIndex+1];
  Caption:='';
  with FileListExplorer1.FileSystem do
    for a:=0 to FFiles.Count-1 do begin
      Caption:=Caption+'        '+FFiles[a];
      Result:=Result and
              ((not (ooFileMustExist in FOptions)) or FileExists(CurrentDirectory+FFiles[a])) and
              ((t='') or (not (ooExtensionMustMatch in FOptions)) or FilterString(FFiles[a],t));
    end;
end;

procedure TFileSystemOpenDialogForm.FormShow(Sender: TObject);
begin
  inherited;
  FileListExplorer1.MultiSelect:=ooMultiSelect in FOptions;
end;

initialization
  RegisterClass(TFileSystemOpenDialogForm);
end.
