unit FileSystemSaveDialog;

interface

uses
  Messages, SysUtils, Windows, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FileSystemBrowseDialog, ImgList, Menus, FileListExplorer, SmartEdit,
  StdCtrls, FolderComboBox, ExtCtrls, ToolWin, ComCtrls, CustomFileSystem;

type
  TFileSystemSaveDialogOption=(soResize,soExtensionMustMatch,soReadOnlyFileSystem);

  TFileSystemSaveDialogOptions=set of TFileSystemSaveDialogOption;

  TFileSystemSaveDialogForm = class(TFileSystemBrowseDialogForm)
  private
    FOptions: TFileSystemSaveDialogOptions;
  public
    function CheckSmartEdit:Boolean;override;
  end;

  TFileSystemSaveDialog=class(TFileSystemBrowseDialog)
  private
    FOptions: TFileSystemSaveDialogOptions;
  protected
    function GetFileSystemBrowseDialogFormClass:TFileSystemBrowseDialogFormClass;override;
    procedure DoExecute;override;
  public
  published
    constructor Create(AOwner:TComponent);override;

    property Options:TFileSystemSaveDialogOptions read FOptions write FOptions;

    destructor Destroy;override;
  end;

implementation

{$R *.dfm}

{ TFileSystemSaveDialog }

constructor TFileSystemSaveDialog.Create(AOwner: TComponent);
begin
  inherited;
end;

destructor TFileSystemSaveDialog.Destroy;
begin
  inherited;
end;

procedure TFileSystemSaveDialog.DoExecute;
begin
  inherited;
  TFileSystemSaveDialogForm(FFileSystemBrowseDialogForm).FOptions:=FOptions;
  if soResize in FOptions then
    FFileSystemBrowseDialogForm.BorderStyle:=bsSizeable
  else
    FFileSystemBrowseDialogForm.BorderStyle:=bsDialog;
end;

function TFileSystemSaveDialog.GetFileSystemBrowseDialogFormClass: TFileSystemBrowseDialogFormClass;
begin
  Result:=TFileSystemSaveDialogForm;
end;

{ TFileSystemSaveDialogForm }

function TFileSystemSaveDialogForm.CheckSmartEdit: Boolean;
var
  k:TCharSet;
  a:Integer;
  s,t:string;
begin
  Result:=inherited CheckSmartEdit;
  s:=SmartEdit1.Text;
  k:=['|','/','\',':','"','<','>'];
  for a:=1 to Length(s) do
    Result:=Result and not (s[a] in k);
  FFiles.DelimitedText:=s;
  t:='';
  if ComboBox1.ItemIndex>-1 then
    t:=FFilters[2*ComboBox1.ItemIndex+1];
  with FileListExplorer1.FileSystem do
    for a:=0 to FFiles.Count-1 do
      Result:=Result and
              ((t='') or (not (soExtensionMustMatch in FOptions)) or FilterString(FFiles[a],t));
end;

initialization
  RegisterClass(TFileSystemSaveDialogForm);
end.
