unit FilterEditorForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DesignIntf, DesignEditors, Grids, ValEdit, FileSystemBrowseDialog, 
  StdCtrls, Buttons, CustomFileSystem;

type
  TFilterEditor = class(TForm)
    ValueListEditor1: TValueListEditor;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure ValueListEditor1Validate(Sender: TObject; ACol,
      ARow: Integer; const KeyName, KeyValue: String);
  private
  public
  end;

  TFileFilterPropertyEditor=class(TPropertyEditor)
  public
    function GetAttributes:TPropertyAttributes;override;
    function GetValue:string;override;
    procedure SetValue(const aValue:string);override;
    procedure Edit;override;
  end;

var
  FilterEditor: TFilterEditor;

procedure Register;

implementation

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(string),TFileSystemBrowseDialog,'Filters',TFileFilterPropertyEditor);
end;

{$R *.dfm}

{ TFileFilterPropertyEditor }

procedure TFileFilterPropertyEditor.Edit;
var
  a:Integer;
  s,s1,s2,s3:string;
begin
  while FilterEditor.ValueListEditor1.RowCount>2 do
    FilterEditor.ValueListEditor1.DeleteRow(1);
  if FilterEditor.ValueListEditor1.RowCount=2 then begin
    FilterEditor.ValueListEditor1.Cells[0,1]:='';
    FilterEditor.ValueListEditor1.Cells[1,1]:='';
  end;
  s:=GetStrValue;
  while s<>'' do begin
    SplitString(s,s1,s2,['|'],False);
    s:=s2;
    SplitString(s,s2,s3,['|'],False);
    s:=s3;
    FilterEditor.ValueListEditor1.InsertRow(s1,s2,True);
  end;
  s:='';
  if FilterEditor.ShowModal=mrOk then begin
    for a:=1 to FilterEditor.ValueListEditor1.RowCount-1 do
      s:=s+'|'+FilterEditor.ValueListEditor1.Cells[0,a]+'|'+FilterEditor.ValueListEditor1.Cells[1,a];
    SetStrValue(Copy(s,2,Length(s)-1));
  end;
end;

function TFileFilterPropertyEditor.GetAttributes: TPropertyAttributes;
begin
  Result:=[paDialog,paMultiSelect,paReadOnly];
end;

function TFileFilterPropertyEditor.GetValue: string;
begin
  Result:=GetStrValue;
end;

procedure TFileFilterPropertyEditor.SetValue(const aValue: string);
begin
  SetStrValue(aValue)
end;

procedure TFilterEditor.ValueListEditor1Validate(Sender: TObject; ACol,
  ARow: Integer; const KeyName, KeyValue: String);
var
  k:TCharSet;
  c:Char;
  t:Boolean;
  s:string;
  a:Integer;
begin
  if ACol=0 then
    k:=['|']
  else
    k:=['|','/','\',':','"','<','>'];
  t:=True;
  s:=ValueListEditor1.Cells[ACol,ARow];
  for a:=1 to Length(s) do
    t:=t and not (s[a] in k);
  if not t then begin
    s:='';
    for c:=#0 to #255 do
      if c in k then
        s:=s+' '+c+' ';
    SafeCallException(Exception.Create('The value cannot contain the following characters: '+s),nil);
    raise Exception.Create('The value cannot contain the following characters: '+s);
  end;
//  showmessage('oui');
end;

initialization
  FilterEditor:=TFilterEditor.Create(nil)
finalization
  FilterEditor.Destroy;
end.
