unit ComponentCollectionItemEditor;

interface

uses
  Messages, SysUtils, Windows, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, ComponentCollection, DesignIntf;

type
  IComponentCollectionItemParent=interface
    ['{30E38D75-0742-453F-8FC2-40C94868E517}']
    procedure Select(Item:TComponent);
    procedure Edit(Item:TComponent);
  end;

  TComponentCollectionItemEditorFrame = class(TFrame,IComponentCollectionNotifier)
  private
    FComponentCollection:TComponentCollection;
    FReference:Pointer;
  protected
    FItem:TComponent;
    FDesigner:IDesigner;

    procedure ReloadList(Sender:TComponentCollection);virtual;
  public
    constructor Create(AOwner:TComponent;AParent:TWinControl;AItem:TComponent;AReference:Pointer;ADesigner:IDesigner);reintroduce;virtual;

    property ComponentCollection:TComponentCollection read FComponentCollection;

    destructor Destroy;override;
  end;

  TComponentCollectionItemEditorFrameClass=class of TComponentCollectionItemEditorFrame;

implementation

{$R *.dfm}

{ TComponentCollectionItemEditorFrame }

constructor TComponentCollectionItemEditorFrame.Create(AOwner: TComponent;
  AParent: TWinControl; AItem: TComponent; AReference: Pointer; ADesigner: IDesigner);
var
  i:IComponentCollectionOwner;
begin
  inherited Create(AOwner);
  Parent:=AParent;
  FItem:=AItem;
  if (FItem as IInterface).QueryInterface(IComponentCollectionOwner,i)=0 then begin
    FComponentCollection:=i.ComponentCollection;
    FComponentCollection.AddNotifier(Self);
  end;
  FReference:=AReference;
  Pointer(FReference^):=Self;
  FDesigner:=ADesigner;
end;

destructor TComponentCollectionItemEditorFrame.Destroy;
begin
  Pointer(FReference^):=nil;
  inherited;
end;

procedure TComponentCollectionItemEditorFrame.ReloadList(
  Sender: TComponentCollection);
begin

end;

end.
