unit HTMLGraphicObject;

interface

uses
  Classes,HTMLDocument,HTTPGraphicFile,HTTPDistantAccess;

type
  THTMLGraphicObject=class(THTMLObject)
  private
    FHTTPGraphicFile: THTTPGraphicFile;

    procedure SetHTTPGraphicFile(const Value: THTTPGraphicFile);
  protected
    function GetHTMLTag:string;override;
    function GetStyleParams:string;override;

    procedure Notification(AComponent: TComponent; Operation: TOperation);override;
  public
    constructor Create(AOwner:TComponent);override;
  published
    property HTTPGraphicFile:THTTPGraphicFile read FHTTPGraphicFile write SetHTTPGraphicFile;

    property Width;
    property Height;
    property Align;

    property OnClick;
    property OnDblClick;
  end;

implementation

{ THTMLGraphicObject }

constructor THTMLGraphicObject.Create(AOwner: TComponent);
begin
  inherited;
  RegisterAdditionalVariantResource('width',FWidth);
  RegisterAdditionalVariantResource('height',FHeight);
  RegisterAdditionalVariantResource('align',FAlign);
  FWidth:=100;
  FHeight:=100;
end;

function THTMLGraphicObject.GetHTMLTag: string;
begin
  Result:='IMG';
end;

function THTMLGraphicObject.GetStyleParams: string;
begin
  if Assigned(FHTTPGraphicFile) then
    Result:='Src="'+FHTTPGraphicFile.HTTPFileName+'"';
  Result:=Result+' '+(inherited GetStyleParams);
end;

procedure THTMLGraphicObject.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if AComponent=FHTTPGraphicFile then
    HTTPGraphicFile:=nil;
end;

procedure THTMLGraphicObject.SetHTTPGraphicFile(
  const Value: THTTPGraphicFile);
begin
  FHTTPGraphicFile := Value;
  if Assigned(FHTTPGraphicFile) then
    FHTTPGraphicFile.FreeNotification(Self);
end;

end.
