unit HTMLMemo;

interface

uses
  Classes,HTMLDocument,HTTPDistantAccess;

type
  THTMLMemo=class(THTMLFormControl)
  private
    FColumnCount: Variant;
    FItems: TStrings;
    FRowCount: Variant;
    
    procedure SetItems(const Value: TStrings);
  protected
    function GetHTMLTag:string;override;
    function ClosedHTMLTag:Boolean;override;
    function GetInteriorHTMLCode:string;override;
    function GetStyleParams:string;override;
  public
    constructor Create(AOwner:TComponent);override;

    destructor Destroy;override;
  published
    property Items:TStrings read FItems write SetItems;
    property ReadOnly;
    property ColumnCount:Variant read FColumnCount write FColumnCount;
    property RowCount:Variant read FRowCount write FRowCount;
  end;

implementation

{ THTMLMemo }

function THTMLMemo.ClosedHTMLTag: Boolean;
begin
  Result:=True;
end;

constructor THTMLMemo.Create(AOwner: TComponent);
begin
  inherited;
  RegisterAdditionalVariantResource('cols',FColumnCount);
  RegisterAdditionalVariantResource('rows',FRowCount);
  FItems:=TStringList.Create;
end;

destructor THTMLMemo.Destroy;
begin
  FItems.Destroy;
  inherited;
end;

function THTMLMemo.GetHTMLTag: string;
begin
  Result:='TEXTAREA';
end;

function THTMLMemo.GetInteriorHTMLCode: string;
begin
  Result:=FItems.Text;
end;

function THTMLMemo.GetStyleParams: string;
begin
  Result:=(inherited GetStyleParams);
  if FColumnCount<>'' then
    Result:=Result+'Cols="'+FColumnCount+'" ';
  if FRowCount<>'' then
    Result:=Result+'Rows="'+FRowCount+'" ';
end;

procedure THTMLMemo.SetItems(const Value: TStrings);
begin
  FItems.Assign(Value);
end;

end.
