unit HTMLRadioGroup;

interface

uses
  SysUtils,Classes,HTMLDocument,HTTPGraphicFile,HTTPDistantAccess;

type

  THTMLRadioGroup=class(THTMLFormControl)
  private
    FItems: TStrings;
    FItemIndex: Variant;
    FAutoLineBreak: Boolean;
    
    procedure SetItems(const Value: TStrings);
    procedure SetAutoLineBreak(const Value: Boolean);
  protected
    function GetSubFormCode:string;override;
    function GetStyleParams:string;override;
    function GetJVPathName:string;override;
  public
    constructor Create(AOwner:TComponent);override;

    destructor Destroy;override;
  published
    property Items:TStrings read FItems write SetItems;
    property IemIndex:Variant read FItemIndex write FItemIndex;
    property AutoLineBreak:Boolean read FAutoLineBreak write SetAutoLineBreak;
  end;

implementation

{ THTMLRadioGroup }

constructor THTMLRadioGroup.Create(AOwner: TComponent);
begin
  inherited;
  FItems:=TStringList.Create;
end;

destructor THTMLRadioGroup.Destroy;
begin
  FItems.Destroy;
  inherited;
end;

function THTMLRadioGroup.GetJVPathName: string;
begin
  Result:='Form'+Name;
//  Result:=inherited GetJVPathName;
end;

function THTMLRadioGroup.GetStyleParams: string;
begin
  Result:=inherited GetStyleParams;
end;

function THTMLRadioGroup.GetSubFormCode: string;
var
  a:Integer;
  s:string;
begin
  s:=GetStyleParams;
  Result:='';
  for a:=0 to FItems.Count-1 do begin
    Result:=Result+'<INPUT Type="radio" Value="'+Inttostr(a)+'" ';
    if FItemIndex=a then
      Result:=Result+'Checked ';
    Result:=Result+s+'><LABEL For="Form'+Name+'.elements['+IntToStr(a)+']">'+FItems[a]+'</LABEL>';
    if FAutoLineBreak then
      Result:=Result+'<BR>';
  end;
end;

procedure THTMLRadioGroup.SetAutoLineBreak(const Value: Boolean);
begin
  FAutoLineBreak := Value;
end;

procedure THTMLRadioGroup.SetItems(const Value: TStrings);
begin
  FItems.Assign(Value);
end;

end.
