unit HTTPFilesEditor;

interface

uses
  Messages, SysUtils, Windows, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, HTTPDistantAccess, DesignIntf, DesignEditors, StdCtrls, ComCtrls,
  ToolWin, ExtCtrls, ComponentCollection;

type
  THTTPFilesEditorForm=class;

  THTTPFilesProperty=class(TClassProperty)
  public
    function GetAttributes:TPropertyAttributes;override;
    procedure Edit;override;
  end;

  THTMLObjectsProperty=class(TClassProperty)
  public
    function GetAttributes:TPropertyAttributes;override;
    procedure Edit;override;
  end;

  THTTPFilesEditorForm = class(TForm,IComponentCollectionDesigner)
    TreeView1: TTreeView;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    Splitter1: TSplitter;
    ScrollBox1: TScrollBox;
    procedure ToolButton1Click(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
  private
    FDesigner:IDesigner;
    FHTTPFiles:THTTPFiles;
    procedure ReloadList(Sender:TPersistent);
  public
    constructor Create(AHTTPFilesProperty:THTTPFilesProperty);reintroduce;
  end;

implementation

{$R *.dfm}

{ THTTPFilesProperty }

procedure THTTPFilesProperty.Edit;
var
  FHTTPFiles:THTTPFiles;
begin
  FHTTPFiles:=THTTPFiles(GetOrdValue);
  if not Assigned(FHTTPFiles.Designer) then
    FHTTPFiles.Designer:=THTTPFilesEditorForm.Create(Self);
  TForm(FHTTPFiles.Designer).Show;
end;

function THTTPFilesProperty.GetAttributes: TPropertyAttributes;
begin
  Result:=[paDialog];
end;

{ THTTPFilesEditorForm }

constructor THTTPFilesEditorForm.Create(
  AHTTPFilesProperty: THTTPFilesProperty);
begin
  inherited Create(nil);
  FDesigner:=AHTTPFilesProperty.Designer;
  FHTTPFiles:=THTTPFiles(AHTTPFilesProperty.GetOrdValue);
  Caption:=AHTTPFilesProperty.Designer.Root.Name+'.'+FHTTPFiles.Owner.GetNamePath+'.HTTPFiles';
  ReloadList(FHTTPFiles);
end;

procedure THTTPFilesEditorForm.ReloadList(Sender: TPersistent);
var
  a:Integer;
begin
  TreeView1.Items[0].DeleteChildren;
  for a:=0 to FHTTPFiles.Count-1 do
    TreeView1.Items.AddChildObject(TreeView1.Items[0],FHTTPFiles.Files[a].Name,FHTTPFiles.Files[a]);
  TreeView1.Select([TreeView1.Items[0]]);
  TreeView1.Items[0].Expand(False);
end;

procedure THTTPFilesEditorForm.ToolButton1Click(Sender: TObject);
var
  f:THTTPFile;
begin
  f:=THTTPFile(FDesigner.CreateComponent(THTTPDocument,FHTTPFiles.Owner,0,0,0,0));
  f.SetParentComponent(FHTTPFiles.Owner);
  FHTTPFiles.AddFile(f);
end;

procedure THTTPFilesEditorForm.TreeView1Change(Sender: TObject;
  Node: TTreeNode);
var
  n:TTreeNode;
begin
  if TreeView1.Selected<>nil then
end;

{ THTMLFilesProperty }

procedure THTMLObjectsProperty.Edit;
begin
  Beep(440,10);
end;

function THTMLObjectsProperty.GetAttributes: TPropertyAttributes;
begin
  Result:=[paDialog];
end;

end.
