unit HTTPMemo;

interface

uses
  Classes,HTMLDocument,HTTPDistantAccess;

type
  THTMLMemo=class(THTMLFormControl)
  private
    FColumns: Variant;
    FItems: TStrings;
    procedure SetItems(const Value: TStrings);
  protected
    function GetHTMLTag:string;override;
    function ClosedHTMLTag:Boolean;override;
    function GetInteriorHTMLCode:string;override;
  public
    constructor Create(AOwner:TComponent);override;

    destructor Destroy;override;
  published
    property Items:TStrings read FItems write SetItems;
    property ReadOnly;
    property Columns:Variant read FColumns write FColumns;
  end;

implementation

{ THTMLMemo }

function THTMLMemo.ClosedHTMLTag: Boolean;
begin
  Result:=True;
end;

constructor THTMLMemo.Create(AOwner: TComponent);
begin
  inherited;
  RegisterAdditionalVariantResource('cols',FColumns);
  FItems:=TStringList.Create;
end;

destructor THTMLMemo.Destroy;
begin
  FItems.Destroy;
  inherited;
end;

function THTMLMemo.GetHTMLTag: string;
begin
  Result:='TEXTAREA';
end;

function THTMLMemo.GetInteriorHTMLCode: string;
begin
  Result:=FItems.Text;
end;

procedure THTMLMemo.SetItems(const Value: TStrings);
begin
  FItems.Assign(Value);
end;

end.
