unit HTTPServerModuleReg;

interface

uses
  Windows,Classes,ToolsAPI,HTTPServerModule,DesignIntf,DesignEditors,ExptIntf,EditIntf,Graphics,
  ToolIntf;

type
  THTTPServerModuleExpert=class(TIExpert)
  public
    function GetName:string;override;
    function GetAuthor:string;override;
    function GetComment:string;override;
    function GetPage:string;override;
    function GetGlyph:HICON;override;
    function GetStyle:TExpertStyle;override;
    function GetState:TExpertState;override;
    function GetIDString:string;override;
    function GetMenuText:string;override;
    procedure Execute;override;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterCustomModule(THTTPServerDataModule,TCustomModule);
  RegisterLibraryExpert(THTTPServerModuleExpert.Create);
end;

{ THTTPServerModuleExpert }

procedure THTTPServerModuleExpert.Execute;
var
  ModuleName, FormName, FileName: string;
  ModIntf:TIModuleInterface;
begin
  ToolServices.GetNewModuleAndClassName('HTTPServerDataModule',ModuleName,FormName,FileName);
  ModIntf:=ToolServices.CreateModuleEx(FileName,FormName,'HTTPServerDataModule','',nil,nil,[cmNewForm,cmAddToProject,cmUnNamed]);
  ModIntf.ShowSource;
  ModIntf.ShowForm;
  ModIntf.Release;
end;

function THTTPServerModuleExpert.GetAuthor: string;
begin
  Result:='Forman'
end;

function THTTPServerModuleExpert.GetComment: string;
begin
  Result:='Create your own web site to use with THTTPServer';
end;

function THTTPServerModuleExpert.GetGlyph: HICON;
begin
  Result:=0;
end;

function THTTPServerModuleExpert.GetIDString: string;
begin
  Result:='Forman.HTTPServerModuleExpert';
end;

function THTTPServerModuleExpert.GetMenuText: string;
begin
  Result:='Create a new HTTP server module';
end;

function THTTPServerModuleExpert.GetName: string;
begin
  Result:='HTTP server module';
end;

function THTTPServerModuleExpert.GetPage: string;
begin
  Result:='HTTP';
end;

function THTTPServerModuleExpert.GetState: TExpertState;
begin
  Result:=[esEnabled];
end;

function THTTPServerModuleExpert.GetStyle: TExpertStyle;
begin
  Result:=esForm;
end;

end.
