unit Unit1;

interface

uses
  Messages, SysUtils, Windows, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPServer, IdCustomHTTPServer,
  IdHTTPServer, StdCtrls, ComCtrls, Menus, HTTPDistantAccess,
  HTMLDocument, HTTPGraphicFile, jpeg, ComponentCollection,
  HTMLGraphicObject, HTMLPasswordRequestFile, HTMLInputObject,
  HTMLListObject, Unit2, HTTPServerModule, ImgList, ShellAPI,
  FileSystemBrowseDialog, FileSystemSaveDialog, FTPLoginDialog,
  CustomFileSystem, FTPFileSystem, Buttons, ExtCtrls, IniFiles,
  Winsock, LocalFileSystem, TypInfo, IdTCPConnection, IdTCPClient, IdHTTP,
  XPMan;

const
  WM_SYSTRAYICON=WM_USER+1;

type
  TForm1 = class(TForm)
    HTTPDistantPCAccess1: THTTPDistantPCAccess;
    HTMLPasswordRequestFile1: THTMLPasswordRequestFile;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    StatusBar1: TStatusBar;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    Button2: TButton;
    Button3: TButton;
    UpDown1: TUpDown;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    Image1: TImage;
    GroupBox2: TGroupBox;
    CheckBox2: TCheckBox;
    StaticText4: TStaticText;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    FTPFileSystem1: TFTPFileSystem;
    FTPLoginDialog1: TFTPLoginDialog;
    FileSystemSaveDialog1: TFileSystemSaveDialog;
    ListView1: TListView;
    Panel1: TPanel;
    Edit2: TEdit;
    Edit3: TEdit;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Image2: TImage;
    StaticText7: TStaticText;
    Button1: TButton;
    Edit4: TEdit;
    CheckBox3: TCheckBox;
    ListView2: TListView;
    ImageList1: TImageList;
    ImageList2: TImageList;
    Timer1: TTimer;
    CheckBox4: TCheckBox;
    IdHTTP1: TIdHTTP;
    Panel2: TPanel;
    Panel3: TPanel;
    XPManifest1: TXPManifest;
    procedure Button1Click(Sender: TObject);
    procedure HTTPDistantPCAccess1ServerOnline(Sender: TObject);
    procedure HTTPDistantPCAccess1ServerOffline(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Edit4Exit(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure FTPFileSystem1Echo(Sender: TObject; EchoStr: String);
    procedure HTTPDistantPCAccess1Echo(Sender: TObject;
      EchoType: TEchoType; EchoStr: String);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListView2Compare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure ListView2ColumnClick(Sender: TObject; Column: TListColumn);
    procedure Timer1Timer(Sender: TObject);
  private
    FSortIncrease,FSortListColumnId:Integer;
    NID:TNotifyIconData;

    procedure WMSysTrayIcon(var Message:TMessage);message WM_SYSTRAYICON;
    procedure WMSysCommand(var Message:TMessage);message WM_SYSCOMMAND;
  public
    procedure LoadConfig;
    procedure SaveConfig;
    procedure UploadRedirection;
    function GetLocalIp:string;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  ShellExecute(0,'OPEN',PChar('http://127.0.0.1:'+IntToStr(HTTPDistantPCAccess1.DefaultPort)),nil,nil,SW_SHOWNORMAL);
end;

procedure TForm1.LoadConfig;
var
  f:TIniFile;
  a,n:Integer;
begin
  f:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));

  CheckBox1.Checked:=f.ReadBool('Connection','Auto connect at startup',False);
  UpDown1.Position:=f.ReadInteger('Connection','Server port',80);
  UpDown1Click(nil,btNext);

  CheckBox2.Checked:=f.ReadBool('Redirection','Use automatic redirection',False);
  CheckBox4.Checked:=f.ReadBool('Redirection','Use external IP',False);
  FTPFileSystem1.Host:=f.ReadString('Redirection','FTP host','');
  FTPFileSystem1.UserName:=f.ReadString('Redirection','FTP UserName','');
  FTPFileSystem1.PassWord:=f.ReadString('Redirection','FTP PassWord','');
  Edit1.Text:=f.ReadString('Redirection','FTP file name','');
  CheckBox3.Checked:=f.ReadBool('Redirection','HTML popup link',True);

  n:=f.ReadInteger('Accounts','Accounts count',0);
  ListView1.Tag:=1;
  for a:=0 to n-1 do begin
    Edit2.Text:=f.ReadString('Accounts','Account'+IntToStr(a)+'.UserName','');
    Edit3.Text:=f.ReadString('Accounts','Account'+IntToStr(a)+'.PassWord','');
    Button5Click(nil);
  end;
  ListView1.Tag:=0;

  f.Destroy;

  if CheckBox1.Checked then
    Button2.Click;
end;

procedure TForm1.SaveConfig;
var
  f:TIniFile;
  a:Integer;
begin
  f:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));

  f.WriteBool('Connection','Auto connect at startup',CheckBox1.Checked);
  f.WriteInteger('Connection','Server port',UpDown1.Position);

  f.WriteBool('Redirection','Use automatic redirection',CheckBox2.Checked);
  f.WriteBool('Redirection','Use external IP',CheckBox4.Checked);
  f.WriteString('Redirection','FTP host',FTPFileSystem1.Host);
  f.WriteString('Redirection','FTP UserName',FTPFileSystem1.UserName);
  f.WriteString('Redirection','FTP PassWord',FTPFileSystem1.PassWord);
  f.WriteString('Redirection','FTP file name',Edit1.Text);
  f.WriteBool('Redirection','HTML popup link',CheckBox3.Checked);

  f.EraseSection('Accounts');
  f.WriteInteger('Accounts','Accounts count',HTMLPasswordRequestFile1.Accounts.Count);
  for a:=0 to HTMLPasswordRequestFile1.Accounts.Count-1 do begin
    f.WriteString('Accounts','Account'+IntToStr(a)+'.UserName',HTMLPasswordRequestFile1.Accounts[a].Username);
    f.WriteString('Accounts','Account'+IntToStr(a)+'.PassWord',HTMLPasswordRequestFile1.Accounts[a].Password);
  end;

  f.Destroy;
end;

procedure RecSetEnabled(Root:TControl;Value:Boolean);
var
  a:Integer;
begin
  Root.Enabled:=Value;
  if Root is TWinControl then
    with Root as TWinControl do
      for a:=ControlCount-1 downto 0 do
        RecSetEnabled(Controls[a],Value);
end;

procedure TForm1.HTTPDistantPCAccess1ServerOnline(Sender: TObject);
begin
  UpDown1.Enabled:=False;
  Edit4.Enabled:=False;
  RecSetEnabled(GroupBox2,False);
  Button1.Enabled:=True;
  Button2.Enabled:=False;
  Button3.Enabled:=True;
  Image1.BringToFront;
  StaticText3.Caption:='Online';
  ImageList2.GetIcon(1,Icon);
  if CheckBox2.Checked then begin
    Timer1.Enabled:=True;
    UploadRedirection;
  end;
end;

procedure TForm1.HTTPDistantPCAccess1ServerOffline(Sender: TObject);
begin
  UpDown1.Enabled:=True;
  Edit4.Enabled:=True;
  RecSetEnabled(GroupBox2,True);
  Button1.Enabled:=False;
  Button2.Enabled:=True;
  Button3.Enabled:=False;
  Image2.BringToFront;
  StaticText3.Caption:='Offline';
  ImageList2.GetIcon(0,Icon);
  Timer1.Enabled:=False;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if FileSystemSaveDialog1.Execute then
    Edit1.Text:=FileSystemSaveDialog1.CurrentDirectory+FileSystemSaveDialog1.FileName;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked and HTTPDistantPCAccess1.Active then
    UploadRedirection;
end;

procedure TForm1.UploadRedirection;
var
  s:string;
  t:TStream;
begin
  if Edit1.Text='' then
    SpeedButton1Click(nil);
  if Edit1.Text='' then begin
    CheckBox2.Checked:=False;
    Exit;
  end;
  FTPFileSystem1.LoginDialog:=nil;
  try
    FTPFileSystem1.Connect;
    s:=GetLocalIp+':'+IntToStr(HTTPDistantPCAccess1.DefaultPort);
    s:='<HTML>'#13+
       '  <BODY>'#13+
       '    <A HRef="http://'+s+'"';
    if CheckBox3.Checked then
      s:=s+' Target="New"';
    s:=s+
       '>My computer access</A>'#13+
       '  </BODY>'#13+
       '</HTML>'#13;
    t:=TStringStream.Create(s);
    FTPFileSystem1.WriteStreamToFile(Edit1.Text,t);
    t.Destroy;
  finally
    if FTPFileSystem1.Connected then
      FTPFileSystem1.DisConnect;
    FTPFileSystem1.LoginDialog:=FTPLoginDialog1;
  end;
end;

function TForm1.GetLocalIp: string;
var
  wsaData: TWSAData;
  addr: TSockAddrIn;
  Phe: PHostEnt;
  szHostName: array[0..128] of Char;
begin
  Result := '';
  try
    try
      if CheckBox4.Checked then begin
        Result:=IdHTTP1.Get('http://www.whatismyip.org/');
      end else begin
        if WSAStartup($101, WSAData) <> 0 then
          raise Exception.Create('Cannot initialize WSA');
        try
          if GetHostName(szHostName, 128) <> SOCKET_ERROR then
          begin
            Phe := GetHostByName(szHostName);
            if Assigned(Phe) then
            begin
              addr.sin_addr.S_addr := longint(plongint(Phe^.h_addr_list^)^);
              Result := inet_ntoa(addr.sin_addr);
            end;
          end;
        finally
          WSACleanup;
        end;
      end;
    except
      on e:Exception do begin
        Result:='Error: '+e.Message;
        raise;
      end else
        raise;
    end;
  finally
    StaticText7.Caption:='Automatic Ip detection: '+Result;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  HTTPDistantPCAccess1.Active:=True;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  HTTPDistantPCAccess1.Active:=False;
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  HTTPDistantPCAccess1.DefaultPort:=Updown1.Position;
end;

procedure TForm1.Edit4Exit(Sender: TObject);
begin
  try
    Updown1.Position:=StrToInt(Edit4.Text);
    UpDown1Click(nil,btNext);
  except
    Edit4.Text:=IntToStr(Updown1.Position);
    Edit4.SetFocus;
    raise;
  end;
end;

procedure TForm1.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  if ListView1.Tag>0 then
    Exit;
  if Assigned(ListView1.Selected) then
    with TAccountItem(ListView1.Selected.Data) do begin
      Edit2.Text:=UserName;
      Edit3.Text:=PassWord;
    end;
  Button4.Enabled:=Assigned(ListView1.Selected);
  Button6.Enabled:=Assigned(ListView1.Selected);
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  i:TListItem;
  a:TAccountItem;
begin
  i:=ListView1.Items.Add;
  a:=HTMLPasswordRequestFile1.Accounts.Add;
  i.Data:=a;
  ListView1.Tag:=1;
  ListView1.Selected:=i;
  ListView1.Tag:=0;
  Button4Click(nil);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  TAccountItem(ListView1.Selected.Data).Username:=Edit2.Text;
  TAccountItem(ListView1.Selected.Data).Password:=Edit3.Text;
  ListView1.Selected.SubItems.Clear;
  ListView1.Selected.Caption:=Edit2.Text;
  ListView1.Selected.SubItems.Add(Edit3.Text);
end;
                            
procedure TForm1.Button6Click(Sender: TObject);
begin
  TAccountItem(ListView1.Selected.Data).Destroy;
  ListView1.Selected.Destroy;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  Button5.Enabled:=(Edit2.Text<>'') and (Edit3.Text<>'');
end;

procedure TForm1.FTPFileSystem1Echo(Sender: TObject; EchoStr: String);
begin
  StatusBar1.SimpleText:='FTP: '+EchoStr;
end;

procedure TForm1.HTTPDistantPCAccess1Echo(Sender: TObject;
  EchoType: TEchoType; EchoStr: String);
begin
  with ListView2.Items.Add do begin
    Caption:=Copy(GetEnumName(TypeInfo(TEchoType),Ord(EchoType)),3,100);
    SubItems.Add(DateTimeToStr(Now));
    SubItems.Add(EchoStr);
    ImageIndex:=Ord(EchoType);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ImageList2.GetIcon(0,Icon);
  FSortListColumnId:=1;
  FSortIncrease:=1;
  LoadConfig;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SaveConfig;
end;

procedure TForm1.ListView2Compare(Sender: TObject; Item1, Item2: TListItem;
  Data: Integer; var Compare: Integer);
begin
  if FSortListColumnId=0 then
    Compare:=FSortIncrease*CompareStr(Item1.Caption,Item2.Caption)
  else
    if (Item1.SubItems.Count=2) and (Item2.SubItems.Count=2) then
      Compare:=FSortIncrease*CompareStr(Item1.SubItems[FSortListColumnId-1],Item2.SubItems[FSortListColumnId-1]);
end;

procedure TForm1.ListView2ColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  if FSortListColumnId=Column.Index then
    FSortIncrease:=-FSortIncrease;
  FSortListColumnId:=Column.Index;
  ListView2.CustomSort(nil,0);
end;

procedure TForm1.WMSysTrayIcon(var Message: TMessage);
begin
  if Message.lparam=WM_LBUTTONDBLCLK then begin
    Show;
    Shell_NotifyIcon(NIM_DELETE,@NID);
  end;
end;

procedure TForm1.WMSysCommand(var Message: TMessage);
var
  s:string;
begin
  if Message.WParam=SC_MINIMIZE then begin
    NID.cbSize:=SizeOf(NID);
    NID.Wnd:=Handle;
    NID.uID:=1;
    NID.uCallbackMessage:=WM_SYSTRAYICON;
    NID.hIcon:=Icon.Handle;
    s:=Caption+' ('+StaticText3.Caption+')';
    ZeroMemory(@NID.szTip[0],64);
    CopyMemory(@NID.szTip[0],@s[1],Length(s));
    NID.uFlags:=NIF_MESSAGE or NIF_ICON or NIF_TIP;
    Assert(Shell_NotifyIcon(Nim_ADD,@NID),SysErrorMessage(GetLastError));
    Application.ShowMainForm:=False;
    Hide;
  end else
    inherited;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  try
    UploadRedirection;
  except
  end;
end;

initialization
  RegisterClass(THTTPServerDataModule2);
end.
